/*************************************************************************
 *
 *  $RCSfile: config.hxx,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: pl $ $Date: 2000/11/08 13:11:21 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CONFIG_HXX
#define _CONFIG_HXX

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

struct ImplConfigData;
struct ImplGroupData;

// ----------
// - Config -
// ----------

class Config
{
private:
	XubString			maFileName;
	ByteString			maGroupName;
	ImplConfigData* 	mpData;
	ImplGroupData*		mpActGroup;
	ULONG				mnDataUpdateId;
	USHORT				mnLockCount;
	BOOL				mbPersistence;
	BOOL				mbDummy1;

#ifdef _CONFIG_CXX
	BOOL				ImplUpdateConfig() const;
	ImplGroupData*		ImplGetGroup() const;
#endif

public:
						Config();
						Config( const XubString& rFileName );
						~Config();

	virtual void		Modified();

	const XubString&	GetPathName() const { return maFileName; }
	static XubString	GetDefDirectory();
	static XubString	GetConfigName( const XubString& rPath, const XubString& rBaseName );

	void				SetGroup( const ByteString& rGroup );
	const ByteString&	GetGroup() const { return maGroupName; }
	void				DeleteGroup( const ByteString& rGroup );
	ByteString			GetGroupName( USHORT nGroup ) const;
	USHORT				GetGroupCount() const;
	BOOL				HasGroup( const ByteString& rGroup ) const;

	ByteString			ReadKey( const ByteString& rKey ) const;
	UniString			ReadKey( const ByteString& rKey, rtl_TextEncoding eEncoding ) const;
	ByteString			ReadKey( const ByteString& rKey, const ByteString& rDefault ) const;
	void				WriteKey( const ByteString& rKey, const ByteString& rValue );
	void				WriteKey( const ByteString& rKey, const UniString& rValue, rtl_TextEncoding eEncoding );
	void				DeleteKey( const ByteString& rKey );
	ByteString			GetKeyName( USHORT nKey ) const;
	ByteString			ReadKey( USHORT nKey ) const;
	USHORT				GetKeyCount() const;

	void				EnterLock();
	void				LeaveLock();
	BOOL				IsLocked() const { return (mnLockCount != 0); }
	BOOL				Update();
	void				Flush();

	void				EnablePersistence( BOOL bPersistence = TRUE )
							{ mbPersistence = bPersistence; }
	BOOL				IsPersistenceEnabled() const { return mbPersistence; }

	void				SetLineEnd( LineEnd eLineEnd );
	LineEnd 			GetLineEnd() const;

private:
						Config( const Config& rConfig );
	Config& 			operator = ( const Config& rConfig );
};

#endif // _SV_CONFIG_HXX
